diff --git a/ldap/servers/plugins/replication/urp.c b/ldap/servers/plugins/replication/urp.c
index 0e76699..3d63c64 100644
--- a/ldap/servers/plugins/replication/urp.c
+++ b/ldap/servers/plugins/replication/urp.c
@@ -771,6 +1044,43 @@ urp_fixup_rename_entry(const Slapi_Entry *entry, const char *newrdn, const char
 }
 
 int
+urp_fixup_move_entry (const Slapi_Entry *entry, const Slapi_DN *newsuperior, int opflags)
+{
+    Slapi_PBlock *newpb;
+    int op_result;
+
+    newpb = slapi_pblock_new();
+
+    /* 
+     * Must mark this operation as replicated,
+     * so that the frontend doesn't add extra attributes.
+     */
+    slapi_rename_internal_set_pb_ext(newpb,
+                                     slapi_entry_get_sdn_const (entry),
+                                     slapi_entry_get_rdn_const(entry), /*NewRDN*/
+                                     newsuperior, /*NewSuperior*/
+                                     0, /* !Delete Old RDNS */
+                                     NULL, /*Controls*/
+                                     slapi_entry_get_uniqueid (entry), /*uniqueid*/
+                                     repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                     OP_FLAG_REPLICATED | OP_FLAG_REPL_FIXUP | opflags);
+
+    /* set operation csn to the entry's dncsn */
+	/* TBD check which csn to use 
+    Slapi_Operation *op;
+	CSN *opcsn;
+	opcsn = (CSN *)entry_get_dncsn (entry);
+    slapi_pblock_get (newpb, SLAPI_OPERATION, &op);
+    operation_set_csn (op, opcsn);
+TBD */
+    slapi_modrdn_internal_pb(newpb); 
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+
+    slapi_pblock_destroy(newpb);
+    return op_result;
+}
+
+int
 urp_fixup_delete_entry(const char *uniqueid, const char *dn, CSN *opcsn, int opflags)
 {
     Slapi_PBlock *newpb;
@@ -891,6 +1201,46 @@ urp_add_resolve_parententry(Slapi_PBlock *pb, char *sessionid, Slapi_Entry *entr
         goto bailout;
     }
 
+    if(is_conflict_entry(parententry)) {
+        /* The parent is a conflict entry
+         * Check if a valid entry exists and make this the new parent
+         *
+         * or if no valid entry exists
+         * - check if also a tombstone for the parentdn exists
+         * - compare csns of tombstone and conflict generation
+         * - turn the latest into a valid glue
+         */
+        char *valid_nsuniqueid = urp_get_valid_parent_nsuniqueid(parentdn);
+        if (valid_nsuniqueid) {
+            slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                          "urp_resolve parent entry: found valid parent %s\n", slapi_sdn_get_dn(parentdn));
+            struct slapi_operation_parameters *op_params;
+            slapi_pblock_get( pb, SLAPI_OPERATION_PARAMETERS, &op_params );
+            /* free it ? */
+            op_params->p.p_add.parentuniqueid = valid_nsuniqueid;
+        } else {
+            int op_result;
+            char *tombstone_nsuniqueid = urp_find_tombstone_for_glue(pb, sessionid, parententry, parentdn, opcsn);
+            slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+            if (tombstone_nsuniqueid) {
+                struct slapi_operation_parameters *op_params;
+                slapi_pblock_get( pb, SLAPI_OPERATION_PARAMETERS, &op_params );
+                op_params->p.p_add.parentuniqueid = tombstone_nsuniqueid;
+                rc = LDAP_SUCCESS;
+            } else if (0 == op_result) {
+                rc = urp_conflict_to_glue(sessionid, parententry, parentdn, opcsn);
+                if (rc == 0) {
+                    slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                                  "urp_resolve parent entry: created valid parent from conflict %s\n", slapi_sdn_get_dn(parentdn));
+                } else {
+                    slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                                  "urp_resolve parent entry: cannot resolve parent %s\n", slapi_sdn_get_dn(parentdn));
+                }
+            }
+        }
+        goto bailout;
+    }
+
     /* The parent is healthy */
     /* Now we need to check that the parent has the correct DN */
     if (slapi_sdn_isparent(slapi_entry_get_sdn(parententry), slapi_entry_get_sdn(entry))) {
@@ -928,8 +1278,394 @@ bailout:
     slapi_rdn_free(&add_rdn);
     return rc;
 }
+static int
+urp_add_new_entry_to_conflict (Slapi_PBlock *pb, char *sessionid, Slapi_Entry *addentry, CSN *opcsn)
+{
+    int rc = 0;
+    int op_result;
 
-/*
+    /* Entry to be added is a loser */
+    char *basedn = slapi_entry_get_ndn(addentry);
+    const char *adduniqueid = slapi_entry_get_uniqueid(addentry);
+    char *newdn= get_dn_plus_uniqueid(sessionid, (const Slapi_DN *)addentry, adduniqueid);
+    if(newdn == NULL) {
+        op_result= LDAP_OPERATIONS_ERROR;
+        slapi_pblock_set(pb, SLAPI_RESULT_CODE, &op_result);
+        rc = SLAPI_PLUGIN_NOOP; /* Abort this Operation */
+        slapi_log_err(slapi_log_urp, sessionid,
+                       "urp_add_operation - %s - Add conflict; Unique ID (%s) already in RDN\n",
+                       basedn, adduniqueid);
+    } else {
+        /* Add the nsds5ReplConflict attribute in the mods */
+        Slapi_Attr *attr = NULL;
+        Slapi_Value **vals = NULL;
+        Slapi_Value **csn_vals = NULL;
+        Slapi_DN *sdn = NULL;
+        Slapi_RDN *rdn;
+        char buf[BUFSIZ];
+        char csnstr[CSN_STRSIZE+1];
+
+        PR_snprintf(buf, BUFSIZ, "%s (ADD) %s", REASON_ANNOTATE_DN, basedn);
+        if (slapi_entry_attr_find(addentry, ATTR_NSDS5_REPLCONFLICT, &attr) == 0) {
+            /* ATTR_NSDS5_REPLCONFLICT exists */
+            slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                          "urp_add_operation - New entry has nsds5ReplConflict already\n");
+            vals = attr_get_present_values (attr); /* this returns a pointer to the contents */
+        }
+        if ( vals == NULL || *vals == NULL ) {
+            /* Add new attribute */
+            slapi_entry_add_string(addentry, ATTR_NSDS5_REPLCONFLICT, buf);
+        } else {
+            /*
+             * Replace old attribute. We don't worry about the index
+             * change here since the entry is yet to be added.
+             */
+            slapi_value_set_string(*vals, buf);
+        }
+
+        /* add the ldapsubentry objectclass if not present */
+        slapi_entry_attr_find(addentry, "objectclass", &attr);
+        if (attr != NULL) {
+            struct berval bv;
+            bv.bv_val = "ldapsubentry";
+            bv.bv_len = strlen(bv.bv_val);
+            if (slapi_attr_value_find(attr, &bv) != 0) {
+                Slapi_Value *new_v = slapi_value_new();
+                slapi_value_init_berval(new_v, &bv);
+                slapi_attr_add_value(attr, new_v);
+                slapi_value_free(&new_v);
+                slapi_entry_set_flag(addentry, SLAPI_ENTRY_LDAPSUBENTRY);
+            }
+        }
+        /* add or replace the conflict csn */
+        if (slapi_entry_attr_find (addentry, "conflictcsn", &attr) == 0) {
+            csn_vals = attr_get_present_values (attr);
+        }
+        if (csn_vals == NULL || *csn_vals == NULL ) {
+            slapi_entry_add_string(addentry,"conflictcsn", csn_as_string(opcsn, PR_FALSE, csnstr));
+        } else {
+
+            slapi_value_set_string (*csn_vals, csn_as_string(opcsn, PR_FALSE, csnstr));
+        }
+
+        /* slapi_pblock_get(pb, SLAPI_ADD_TARGET, &dn); */
+        slapi_pblock_get(pb, SLAPI_ADD_TARGET_SDN, &sdn);
+        slapi_sdn_free(&sdn);
+
+        slapi_entry_set_normdn(addentry, newdn); /* dn: passin */
+
+        sdn = slapi_sdn_dup(slapi_entry_get_sdn_const(addentry));
+        slapi_pblock_set(pb, SLAPI_ADD_TARGET_SDN, sdn);
+
+        rdn = slapi_rdn_new_sdn ( slapi_entry_get_sdn_const(addentry) );
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                         "urp_add_operation - Naming conflict ADD. Add %s instead\n",
+                         slapi_rdn_get_rdn(rdn));
+        slapi_rdn_free(&rdn);
+        rc= slapi_setbit_int(rc,SLAPI_RTN_BIT_FETCH_EXISTING_DN_ENTRY);
+
+    }
+    return rc;
+}
+
+static int
+urp_add_check_tombstone (Slapi_PBlock *pb, char *sessionid, Slapi_Entry *entry, CSN *opcsn)
+{
+    int rc = 0;
+    int op_result;
+    Slapi_Entry **entries = NULL;
+    Slapi_PBlock *newpb;
+    char *basedn = slapi_entry_get_ndn(entry);
+    const Slapi_DN *suffix = slapi_get_suffix_by_dn(slapi_entry_get_sdn (entry));
+
+    char *filter = slapi_filter_sprintf("(&(objectclass=nstombstone)(nscpentrydn=%s))", basedn);
+    newpb = slapi_pblock_new();
+    slapi_search_internal_set_pb(newpb,
+                                 slapi_sdn_get_dn(suffix), /* Base DN */
+                                 LDAP_SCOPE_SUBTREE,
+                                 filter,
+                                 NULL, /* Attrs */
+                                 0, /* AttrOnly */
+                                 NULL, /* Controls */
+                                 NULL, /* UniqueID */
+                                 repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                 0);
+    slapi_search_internal_pb(newpb);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+    if ( (op_result != LDAP_SUCCESS) || (entries == NULL) )
+    {
+        /* Log a message */
+        goto done;
+    }
+    for (int i = 0; entries && (entries[i] != NULL); i++) {
+        /* we need to distinguish between normal tombstones abd cenotaphs */
+        int is_cenotaph;
+        CSN *from_csn = NULL;
+        CSN *to_csn = NULL;
+        char *to_value = NULL;
+        char *from_value = slapi_entry_attr_get_charptr(entries[i], "cenotaphfrom");
+        if (from_value) {
+            is_cenotaph = 1;
+            from_csn = csn_new_by_string(from_value);
+            to_value = slapi_entry_attr_get_charptr(entries[i], "cenotaphto");
+            to_csn = csn_new_by_string(to_value);
+            slapi_ch_free_string(&from_value);
+        } else {
+            is_cenotaph = 0;
+            from_csn = csn_dup(entry_get_dncsn(entries[i]));
+            to_value = slapi_entry_attr_get_charptr(entries[i], "nstombstonecsn");
+            to_csn = csn_new_by_string(to_value);
+        }
+        if (csn_compare(from_csn, opcsn) < 0 &&
+            csn_compare(to_csn, opcsn) > 0 ) {
+            slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                           "urp_add_check_tombstone - found conflicting tombstone (%s).\n",
+                           slapi_entry_get_dn_const(entries[i]));
+            rc = 1;
+        } else if (!is_cenotaph && csn_compare(opcsn, from_csn) < 0) {
+            /* the tombstone is from an entry added later than the received one */
+            Slapi_Value *tomb_value;
+            const char *adduniqueid = slapi_entry_get_uniqueid (entries[i]);
+            const char *basedn = slapi_entry_get_dn_const (entry);
+            char *newrdn = get_rdn_plus_uniqueid ( sessionid, basedn, adduniqueid );
+            char *parentdn = slapi_dn_parent_ext(slapi_entry_get_dn_const(entries[i]),1);
+            char *conflict_dn = slapi_ch_smprintf("%s,%s",newrdn, parentdn);
+            slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                           "urp_add_check_tombstone - found tombstone for newer entry(%s) create conflict (%s).\n",
+                           slapi_entry_get_dn_const(entries[i]),conflict_dn);
+            Slapi_DN *conflict_sdn = slapi_sdn_new_dn_byval(conflict_dn);
+            /* need to add the tombstone value here since we need the deletion csn */
+            tomb_value = slapi_value_new_string(SLAPI_ATTR_VALUE_TOMBSTONE);
+            value_update_csn(tomb_value, CSN_TYPE_VALUE_UPDATED, entry_get_deletion_csn(entries[i]));
+            slapi_entry_add_value(entry, SLAPI_ATTR_OBJECTCLASS, tomb_value);
+            slapi_value_free(&tomb_value);
+
+            /* now turn the existing tombstone into a conflict */
+            tombstone_to_conflict(sessionid, slapi_entry_dup(entries[i]), conflict_sdn, "tombstoneToConflict", opcsn, NULL);
+            slapi_pblock_set(pb, SLAPI_URP_TOMBSTONE_CONFLICT_DN, conflict_dn);
+            slapi_ch_free_string(&newrdn);
+            slapi_ch_free_string(&parentdn);
+            slapi_sdn_free(&conflict_sdn);
+            rc = 2;
+        }
+        slapi_ch_free_string(&to_value);
+        csn_free(&from_csn);
+        csn_free(&to_csn);
+
+        if (rc) break;
+    }
+
+done:
+    slapi_free_search_results_internal(newpb);
+    slapi_pblock_destroy(newpb);
+    if (filter) {
+        PR_smprintf_free(filter);
+    }
+    return rc;
+}
+
+static int
+urp_delete_check_conflict (char *sessionid, Slapi_Entry *tombstone_entry, CSN *opcsn)
+{
+    int rc = 0;
+    int op_result = 0;
+    char *filter = NULL;
+    Slapi_PBlock *newpb = NULL;
+    Slapi_Entry **entries = NULL;
+    Slapi_Entry *conflict_e = NULL;
+    char *validdn = slapi_entry_attr_get_charptr(tombstone_entry, "nscpentrydn");
+    char *parent_dn = slapi_dn_parent (validdn);
+
+    filter = slapi_filter_sprintf("(&(objectclass=ldapsubentry)(%s=%s (ADD) %s%s))", ATTR_NSDS5_REPLCONFLICT, REASON_ANNOTATE_DN,
+                                  ESC_NEXT_VAL, validdn);
+    newpb = slapi_pblock_new();
+    slapi_search_internal_set_pb(newpb,
+                                 parent_dn,
+                                 LDAP_SCOPE_SUBTREE,
+                                 filter,
+                                 NULL, /* Attrs */
+                                 0, /* AttrOnly */
+                                 NULL, /* Controls */
+                                 NULL, /* UniqueID */
+                                 repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                 0);
+    slapi_search_internal_pb(newpb);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+
+    if ((op_result != LDAP_SUCCESS) || (entries == NULL) || entries[0] == NULL) {
+        /* Log a message */
+        goto done;
+    }
+
+    conflict_e = slapi_entry_dup(entries[0]);
+    conflict_to_tombstone(sessionid, conflict_e, opcsn);
+    slapi_entry_free(conflict_e);
+    rc = 1;
+done:
+    slapi_free_search_results_internal(newpb);
+    slapi_pblock_destroy(newpb);
+    newpb = NULL;
+    if (filter) {
+        PR_smprintf_free(filter);
+    }
+
+    slapi_ch_free_string(&validdn);
+    slapi_ch_free_string(&parent_dn);
+    return rc;
+}
+
+static char*
+urp_find_valid_entry_to_delete(Slapi_PBlock *pb, const Slapi_Entry *deleteentry, char *sessionid, CSN *opcsn)
+{
+    Slapi_DN *sdnp = NULL;
+    const char *dn;
+    char *delete_nsuniqueid = NULL;
+    Slapi_PBlock *newpb;
+    const CSN *dncsn;
+    Slapi_Entry **entries = NULL;
+    int op_result;
+
+    slapi_pblock_get(pb, SLAPI_DELETE_TARGET_SDN, &sdnp);
+    dn = slapi_sdn_get_dn(sdnp);
+    newpb = slapi_pblock_new();
+    slapi_search_internal_set_pb(newpb,
+                                 dn, /* Base DN */
+                                 LDAP_SCOPE_BASE,
+                                 "objectclass=*",
+                                 NULL, /* Attrs */
+                                 0, /* AttrOnly */
+                                 NULL, /* Controls */
+                                 NULL, /* UniqueID */
+                                 repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                 0);
+    slapi_search_internal_pb(newpb);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+    if ((op_result != LDAP_SUCCESS) || (entries == NULL) || entries[0] == NULL) {
+        /* Log a message */
+        goto done;
+    }
+    dncsn = entry_get_dncsn(entries[0]);
+    if (dncsn && (csn_compare(dncsn, opcsn) < 0 )) {
+        delete_nsuniqueid = slapi_entry_attr_get_charptr(entries[0], "nsuniqueid");
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                    "urp_find_valid_entry_to_delete - found (%s) (%s).\n",
+            delete_nsuniqueid, slapi_entry_get_dn_const(entries[0]));
+    }
+
+done:
+    slapi_free_search_results_internal(newpb);
+    slapi_pblock_destroy(newpb);
+    return delete_nsuniqueid;
+}
+
+static char*
+urp_find_tombstone_for_glue (Slapi_PBlock *pb, char *sessionid, const Slapi_Entry *entry, Slapi_DN *parentdn, CSN *opcsn)
+{
+    char *tombstone_nsuniqueid = NULL;
+    int op_result;
+    int rc = LDAP_SUCCESS;;
+    Slapi_Entry **entries = NULL;
+    Slapi_PBlock *newpb;
+    const char *basedn = slapi_sdn_get_dn(parentdn);
+    char *conflict_csnstr = slapi_entry_attr_get_charptr(entry, "conflictcsn");
+    CSN *conflict_csn = csn_new_by_string(conflict_csnstr);
+    slapi_ch_free_string(&conflict_csnstr);
+    CSN *tombstone_csn = NULL;
+
+    char *filter = slapi_filter_sprintf("(&(objectclass=nstombstone)(nscpentrydn=%s))", basedn);
+    newpb = slapi_pblock_new();
+    char *parent_dn = slapi_dn_parent (basedn);
+    slapi_search_internal_set_pb(newpb,
+                                 parent_dn, /* Base DN */
+                                 LDAP_SCOPE_SUBTREE,
+                                 filter,
+                                 NULL, /* Attrs */
+                                 0, /* AttrOnly */
+                                 NULL, /* Controls */
+                                 NULL, /* UniqueID */
+                                 repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                 0);
+    slapi_search_internal_pb(newpb);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+    if ( (op_result != LDAP_SUCCESS) || (entries == NULL) )
+    {
+        /* Log a message */
+        goto done;
+    }
+    for (int i = 0; entries && (entries[i] != NULL); i++) {
+        char *tombstone_csn_value = slapi_entry_attr_get_charptr(entries[i], "nstombstonecsn");
+        if (tombstone_csn_value) {
+            tombstone_csn = csn_new_by_string(tombstone_csn_value);
+            slapi_ch_free_string(&tombstone_csn_value);
+            if( csn_compare(tombstone_csn, conflict_csn) > 0 ) {
+                slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                               "urp_find_tombstone_for_glue - found tombstone newer than conflict (%s).\n",
+                               slapi_entry_get_dn_const(entries[i]));
+                tombstone_nsuniqueid = slapi_entry_attr_get_charptr(entries[i], "nsuniqueid");
+                rc = tombstone_to_glue (pb, sessionid, entries[i], parentdn, REASON_RESURRECT_ENTRY, opcsn, NULL);
+                if (rc) {
+                    slapi_log_err(SLAPI_LOG_ERR, sessionid,
+                                  "urp_resolve parent entry: failed to create glue from tombstone %s\n", slapi_sdn_get_dn(parentdn));
+                    slapi_ch_free_string(&tombstone_nsuniqueid);
+                    tombstone_nsuniqueid = NULL;
+                }
+                break;
+            }
+        }
+    }
+    csn_free(&tombstone_csn);
+
+done:
+    slapi_pblock_set(pb, SLAPI_PLUGIN_INTOP_RESULT, &rc);
+    csn_free(&conflict_csn);
+    slapi_ch_free_string(&parent_dn);
+    slapi_free_search_results_internal(newpb);
+    slapi_pblock_destroy(newpb);
+    if (filter) {
+        PR_smprintf_free(filter);
+    }
+    return tombstone_nsuniqueid;
+}
+
+static int
+urp_conflict_to_glue (char *sessionid, const Slapi_Entry *entry, Slapi_DN *parentdn, CSN *opcsn)
+{
+    int rc = 0;
+    int op_result;
+    const char *newrdn;
+    Slapi_RDN *parentrdn = slapi_rdn_new();
+    const char *basedn;
+
+    basedn = slapi_entry_get_dn_const (entry);
+    slapi_sdn_get_rdn(parentdn, parentrdn);
+    newrdn = slapi_rdn_get_rdn(parentrdn);
+    if(newrdn) {
+        del_replconflict_attr(entry, opcsn, 0);
+        slapi_log_err(slapi_log_urp, sessionid,
+                      "urp_conflict_to_glue - %s --> %s\n", basedn, newrdn);
+        op_result = urp_fixup_rename_entry ( entry, newrdn, NULL, 0 );
+        switch(op_result) {
+        case LDAP_SUCCESS:
+            break;
+        case LDAP_NO_SUCH_OBJECT:
+            slapi_log_err(slapi_log_urp, sessionid,
+                           "urp_conflict_to_glue failed(%d) - %s --> %s\n", op_result, basedn, newrdn);
+            rc = LDAP_NO_SUCH_OBJECT;
+            break;
+        default: 
+            slapi_log_err(slapi_log_urp, sessionid,
+                           "urp_conflict_to_glue failed(%d) - %s --> %s\n", op_result, basedn, newrdn);
+            rc = 1;
+        }
+        slapi_ch_free ( (void**)&newrdn );
+    }
+    return rc;
+}
+/* 
  * urp_annotate_dn:
  * Returns 0 on failure
  * Returns > 0 on success (1 on general conflict resolution success, LDAP_NO_SUCH_OBJECT on no-conflict success)
@@ -938,7 +1674,7 @@ bailout:
  * a new entry (the operation entry) see urp_add_operation.
  */
 static int
-urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const char *optype)
+urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const char *optype, char **conflict_dn)
 {
     int rc = 0; /* Fail */
     int op_result;
@@ -951,8 +1687,12 @@ urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const cha
     basesdn = slapi_entry_get_sdn_const(entry);
     basedn = slapi_entry_get_dn_const(entry);
     newrdn = get_rdn_plus_uniqueid(sessionid, basedn, uniqueid);
+    if (conflict_dn) {
+        *conflict_dn = NULL;
+    }
     if (newrdn) {
         mod_namingconflict_attr(uniqueid, basesdn, basesdn, opcsn, optype);
+        mod_objectclass_attr(uniqueid, basesdn, basesdn, opcsn, optype);
         slapi_log_err(slapi_log_urp, sessionid,
                       "urp_annotate_dn - %s --> %s\n", basedn, newrdn);
         op_result = urp_fixup_rename_entry(entry, newrdn, NULL, 0);
@@ -961,6 +1701,9 @@ urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const cha
             slapi_log_err(slapi_log_urp, sessionid,
                           "urp_annotate_dn - Naming conflict %s. Renamed existing entry to %s\n",
                           optype, newrdn);
+            if (conflict_dn) {
+                *conflict_dn = slapi_ch_smprintf("%s,%s",newrdn,slapi_dn_find_parent(basedn));
+            }
             rc = 1;
             break;
         case LDAP_NO_SUCH_OBJECT:
@@ -999,6 +1742,85 @@ urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const cha
     return rc;
 }
 
+static char *
+urp_get_valid_parent_nsuniqueid (Slapi_DN *parentdn)
+{
+    Slapi_PBlock *newpb = NULL;
+    Slapi_Entry **entries = NULL;
+    int op_result = LDAP_SUCCESS;
+    char *nsuid = NULL;
+
+    newpb = slapi_pblock_new();
+    slapi_search_internal_set_pb(newpb,
+                                 slapi_sdn_get_dn(parentdn),
+                                 LDAP_SCOPE_BASE,
+                                 "objectclass=*",
+                                 NULL, /* Attrs */
+                                 0, /* AttrOnly */
+                                 NULL, /* Controls */
+                                 NULL, /* UniqueID */
+                                 repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                 0);
+    slapi_search_internal_pb(newpb);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+
+    if ( (op_result != LDAP_SUCCESS) || (entries == NULL) ) {
+        /* Log a message */
+        goto done;
+    }
+
+    nsuid = slapi_entry_attr_get_charptr(entries[0], "nsuniqueid");
+done:
+    slapi_free_search_results_internal(newpb);
+    slapi_pblock_destroy(newpb);
+    newpb = NULL;
+
+    return nsuid;
+}
+
+static int
+urp_rename_conflict_children(const char *old_parent, const Slapi_DN *new_parent)
+{
+    Slapi_PBlock *newpb = NULL;
+    Slapi_Entry **entries = NULL;
+    int op_result = LDAP_SUCCESS;
+    int i;
+
+    newpb = slapi_pblock_new();
+    slapi_search_internal_set_pb(newpb,
+                                 old_parent,
+                                 LDAP_SCOPE_ONELEVEL,
+                                 "(|(objectclass=*)(objectclass=ldapsubentry))",
+                                 NULL, /* Attrs */
+                                 0, /* AttrOnly */
+                                 NULL, /* Controls */
+                                 NULL, /* UniqueID */
+                                 repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+                                 0);
+    slapi_search_internal_pb(newpb);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+    slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+
+    if ((op_result != LDAP_SUCCESS) || (entries == NULL) || entries[0] == NULL) {
+        /* Log a message */
+        goto done;
+    }
+    for (i = 0; NULL != entries[i]; i++) {
+        op_result = urp_fixup_move_entry(entries[i],new_parent,0);
+        slapi_log_err(SLAPI_LOG_REPL, "session test",
+                                     "urp_rename_conflict children - Renaming: %s, Result: %d\n",
+                                      slapi_entry_get_dn_const(entries[i]), op_result);
+    }
+
+done:
+    slapi_free_search_results_internal(newpb);
+    slapi_pblock_destroy(newpb);
+    newpb = NULL;
+
+    return op_result;
+}
+
 /*
  * An URP Naming Collision helper function. Retrieves a list of entries
  * that have the given dn excluding the unique id of the entry. Any
@@ -1008,7 +1830,7 @@ urp_annotate_dn(char *sessionid, const Slapi_Entry *entry, CSN *opcsn, const cha
  * to its RDN.
  */
 static Slapi_Entry *
-urp_get_min_naming_conflict_entry(Slapi_PBlock *pb, char *sessionid, CSN *opcsn)
+urp_get_min_naming_conflict_entry(Slapi_PBlock *pb, const char *collisiondn, char *sessionid, CSN *opcsn)
 {
     Slapi_PBlock *newpb = NULL;
     LDAPControl **server_ctrls = NULL;
@@ -1017,42 +1839,46 @@ urp_get_min_naming_conflict_entry(Slapi_PBlock *pb, char *sessionid, CSN *opcsn)
     const CSN *min_csn = NULL;
     char *filter = NULL;
     char *parent_dn = NULL;
-    char *basedn;
+    const char *basedn;
     int i = 0;
     int min_i = -1;
     int op_result = LDAP_SUCCESS;
 
-    slapi_pblock_get(pb, SLAPI_URP_NAMING_COLLISION_DN, &basedn);
-    if (NULL == basedn || strncmp(basedn, SLAPI_ATTR_UNIQUEID, strlen(SLAPI_ATTR_UNIQUEID)) == 0)
+    if (collisiondn) {
+        basedn = collisiondn;
+    } else {
+        slapi_pblock_get (pb, SLAPI_URP_NAMING_COLLISION_DN, &basedn);
+    }
+    if (NULL == basedn || strncmp (basedn, SLAPI_ATTR_UNIQUEID, strlen(SLAPI_ATTR_UNIQUEID)) == 0)
         return NULL;
 
     slapi_log_err(SLAPI_LOG_REPL, sessionid,
                   "urp_get_min_naming_conflict_entry - %s\n", basedn);
 
-    filter = slapi_filter_sprintf("(%s=%s %s%s)", ATTR_NSDS5_REPLCONFLICT, REASON_ANNOTATE_DN,
+    filter = slapi_filter_sprintf("(&(objectclass=ldapsubentry)(%s=%s (ADD) %s%s))", ATTR_NSDS5_REPLCONFLICT, REASON_ANNOTATE_DN,
                                   ESC_NEXT_VAL, basedn);
 
     /* server_ctrls will be freed when newpb is destroyed */
-    server_ctrls = (LDAPControl **)slapi_ch_calloc(2, sizeof(LDAPControl *));
+    server_ctrls = (LDAPControl **)slapi_ch_calloc (2, sizeof (LDAPControl *));
     server_ctrls[0] = create_managedsait_control();
     server_ctrls[1] = NULL;
-
+    
     newpb = slapi_pblock_new();
-    parent_dn = slapi_dn_parent(basedn);
+    parent_dn = slapi_dn_parent (basedn);
     slapi_search_internal_set_pb(newpb,
                                  parent_dn, /* Base DN */
                                  LDAP_SCOPE_ONELEVEL,
                                  filter,
-                                 NULL,         /* Attrs */
-                                 0,            /* AttrOnly */
+                                 NULL, /* Attrs */
+                                 0, /* AttrOnly */
                                  server_ctrls, /* Controls */
-                                 NULL,         /* UniqueID */
+                                 NULL, /* UniqueID */
                                  repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
                                  0);
     slapi_search_internal_pb(newpb);
     slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
     slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
-    if ((op_result != LDAP_SUCCESS) || (entries == NULL)) {
+    if ( (op_result != LDAP_SUCCESS) || (entries == NULL) ) {
         /* Log a message */
         goto done;
     }
@@ -1060,9 +1886,9 @@ urp_get_min_naming_conflict_entry(Slapi_PBlock *pb, char *sessionid, CSN *opcsn)
     for (i = 0; NULL != entries[i]; i++) {
         const CSN *dncsn;
         dncsn = entry_get_dncsn(entries[i]);
-        if ((dncsn != opcsn) &&
+        if ((dncsn != opcsn) && (csn_compare(dncsn, opcsn) > 0 ) &&
             ((min_csn == NULL) || (csn_compare(dncsn, min_csn) < 0)) &&
-            !is_tombstone_entry(entries[i])) {
+            !is_tombstone_entry (entries[i])) {
             min_csn = dncsn;
             min_i = i;
         }
@@ -1077,7 +1903,7 @@ urp_get_min_naming_conflict_entry(Slapi_PBlock *pb, char *sessionid, CSN *opcsn)
             break;
         }
     }
-
+    
     if (min_csn != NULL) {
         /* Found one entry */
         min_naming_conflict_entry = slapi_entry_dup(entries[min_i]);
@@ -1114,20 +1940,36 @@ urp_naming_conflict_removal(Slapi_PBlock *pb, char *sessionid, CSN *opcsn, const
     /*
      * Backend op has set SLAPI_URP_NAMING_COLLISION_DN to the basedn.
      */
-    min_naming_conflict_entry = urp_get_min_naming_conflict_entry(pb, sessionid, opcsn);
+    min_naming_conflict_entry = urp_get_min_naming_conflict_entry(pb, NULL, sessionid, opcsn);
     if (min_naming_conflict_entry == NULL) {
         return 0;
     }
 
+    /* EXPERIMENT - do step 2 before 1 */
+
+    /* Step2: Remove ATTR_NSDS5_REPLCONFLICT from the winning entry */
+    /*
+     * A fixup op will not invoke urp_modrdn_operation(). Even it does,
+     * urp_modrdn_operation() will do nothing because of the same CSN.
+     */
+    op_result = del_replconflict_attr(min_naming_conflict_entry, opcsn, OP_FLAG_ACTION_INVOKE_FOR_REPLOP);
+    if (op_result != LDAP_SUCCESS) {
+        slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                      "urp_naming_conflict_removal - Failed to remove nsds5ReplConflict for %s, err=%d\n",
+                      slapi_entry_get_ndn(min_naming_conflict_entry), op_result);
+    }
+    /* end Step 2 */
     /* Step 1: Restore the entry's original DN */
 
     oldrdn = slapi_rdn_new_sdn(slapi_entry_get_sdn_const(min_naming_conflict_entry));
     oldrdnstr = slapi_rdn_get_rdn(oldrdn);
 
+    slapi_log_err(SLAPI_LOG_REPL, sessionid,
+                   "urp_naming_conflict_removal - Found %s\n", slapi_entry_get_ndn(min_naming_conflict_entry));
     /* newrdnstr is the old rdn of the entry minus the nsuniqueid part */
-    newrdn = slapi_rdn_new_rdn(oldrdn);
-    slapi_rdn_remove_attr(newrdn, SLAPI_ATTR_UNIQUEID);
-    newrdnstr = slapi_rdn_get_rdn(newrdn);
+    newrdn = slapi_rdn_new_rdn ( oldrdn );
+    slapi_rdn_remove_attr (newrdn, SLAPI_ATTR_UNIQUEID );
+    newrdnstr = slapi_rdn_get_rdn(newrdn);        
 
     /*
      * Set OP_FLAG_ACTION_INVOKE_FOR_REPLOP since this operation
